From 015cec311e4ca21fa622a2209c0f52832fb36d2e Mon Sep 17 00:00:00 2001
From: cnangel <cnangel@gmail.com>
Date: Mon, 3 Jun 2013 11:29:50 +0800
Subject: [PATCH] update for cnangel
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit

---
 .gitignore                                 |   70 +
 INSTALL                                    |    1 +
 Makefile.am                                |   17 +-
 aclocal.m4                                 | 8346 +---------------------------
 autogen.sh                                 |   29 +-
 config/ltmain.sh                           | 4038 +++++++++-----
 configure                                  | 4732 +++++++++-------
 configure.in                               |    5 +-
 debian/Makefile.am                         |    9 +
 debian/changelog                           |   12 +
 debian/control                             |   34 +
 debian/copyright                           |   19 +
 debian/liblog4cpp-dev.dirs                 |    2 +
 debian/liblog4cpp-dev.files                |    4 +
 debian/liblog4cpp-doc.dirs                 |    1 +
 debian/liblog4cpp-doc.files                |    1 +
 debian/liblog4cpp0.dirs                    |    1 +
 debian/liblog4cpp0.files                   |    1 +
 debian/liblog4cpp0.postinst                |    7 +
 debian/rules                               |   85 +
 doc/Doxyfile.in                            |    5 +-
 doc/Makefile.am                            |    2 +-
 doc/html/index.html                        |  910 +--
 include/log4cpp/AmberAppender.hh           |  140 +
 include/log4cpp/Appender.hh                |   51 +
 include/log4cpp/Clock.hh                   |   38 +
 include/log4cpp/EventBase.hh               |   90 +
 include/log4cpp/FileAppender.hh            |   50 +
 include/log4cpp/LayoutAppender.hh          |   23 +-
 include/log4cpp/Makefile.am                |    8 +-
 include/log4cpp/Signaler.hh                |   63 +
 include/log4cpp/Thread.hh                  |   59 +
 include/log4cpp/TimeRollingFileAppender.hh |  127 +
 include/log4cpp/config-openvms.h           |    2 +-
 log4cpp-config.in                          |    8 +
 log4cpp.spec.in                            |  103 +-
 m4/BB_CHECK_PTHREADS.m4                    |    7 +-
 m4/ac_config_libconfig_in.m4               |    5 +-
 src/AmberAppender.cpp                      |  125 +
 src/Appender.cpp                           |   46 +
 src/AppendersFactory.cpp                   |    2 +
 src/BufferingAppender.cpp                  |    8 +-
 src/Category.cpp                           |    5 +
 src/Clock.cpp                              |   27 +
 src/EventBase.cpp                          |  209 +
 src/FileAppender.cpp                       |  132 +-
 src/LayoutAppender.cpp                     |   17 +
 src/Makefile.am                            |    8 +-
 src/PatternLayout.cpp                      |    1 +
 src/PropertyConfiguratorImpl.cpp           |   53 +-
 src/RemoteSyslogAppender.cpp               |    2 +-
 src/Signaler.cpp                           |   87 +
 src/Thread.cpp                             |   34 +
 src/TimeRollingFileAppender.cpp            |  212 +
 tests/Makefile.am                          |   10 +-
 tests/testRollingFileAppender.cpp          |    2 +-
 tests/testTimeRollingFileAppender.cpp      |  113 +
 57 files changed, 7991 insertions(+), 12207 deletions(-)
 create mode 100644 .gitignore
 create mode 100644 debian/Makefile.am
 create mode 100644 debian/changelog
 create mode 100644 debian/control
 create mode 100644 debian/copyright
 create mode 100644 debian/liblog4cpp-dev.dirs
 create mode 100644 debian/liblog4cpp-dev.files
 create mode 100644 debian/liblog4cpp-doc.dirs
 create mode 100644 debian/liblog4cpp-doc.files
 create mode 100644 debian/liblog4cpp0.dirs
 create mode 100644 debian/liblog4cpp0.files
 create mode 100644 debian/liblog4cpp0.postinst
 create mode 100644 debian/rules
 create mode 100644 include/log4cpp/AmberAppender.hh
 create mode 100644 include/log4cpp/Clock.hh
 create mode 100644 include/log4cpp/EventBase.hh
 create mode 100644 include/log4cpp/Signaler.hh
 create mode 100644 include/log4cpp/Thread.hh
 create mode 100644 include/log4cpp/TimeRollingFileAppender.hh
 create mode 100644 src/AmberAppender.cpp
 create mode 100644 src/Clock.cpp
 create mode 100644 src/EventBase.cpp
 create mode 100644 src/Signaler.cpp
 create mode 100644 src/Thread.cpp
 create mode 100644 src/TimeRollingFileAppender.cpp
 create mode 100644 tests/testTimeRollingFileAppender.cpp

diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..f14ad25
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,70 @@
+blib*
+Makefile
+Makefile.old
+*~
+*swp
+Build
+_build*
+pm_to_blib*
+*.tar.gz
+*.tar.bz2
+.lwpcookies
+cover_db
+*.bak
+*.log
+config.log
+autom4te.cache
+stamp-h1
+Doxyfile
+compile
+config.status
+myconfig.h
+doc/doxygen
+autom4te.cache
+aclocal.m4
+config.guess
+config.h.in
+config.sub
+configure
+depcomp
+install-sh
+ltmain.sh
+missing
+config.h
+libtool
+*.libs
+*.la
+*.deps
+*Makefile.in
+*.o
+*.lo
+*.loT
+*.out
+*dotest
+*.gcno
+*.gcda
+ilike-*
+.gdb_history
+m4/libtool.m4
+m4/ltoptions.m4
+m4/ltsugar.m4
+m4/ltversion.m4
+m4/lt~obsolete.m4
+log4cpp-config
+log4cpp.pc
+doc/html/api
+doc/man
+tests/testbench
+tests/testmain
+tests/testCategory
+tests/testConfig
+tests/testErrorCollision
+tests/testFilter
+tests/testFixedContextCategory
+tests/testNDC
+tests/testPattern
+tests/testPriority
+tests/testProperties
+tests/testPropertyConfig
+tests/testRollingFileAppender
+tests/testTimeRollingFileAppender
diff --git a/INSTALL b/INSTALL
index 53c5e0b..a8ce75a 100644
--- a/INSTALL
+++ b/INSTALL
@@ -1,2 +1,3 @@
 See 'Building Log4cpp' section of HTML documentation.
 
+reference to README
diff --git a/Makefile.am b/Makefile.am
index 544bf7a..3c09a47 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,3 +1,7 @@
+AUTOMAKE_OPTIONS						= foreign
+
+ACLOCAL_AMFLAGS = -I m4
+
 if DOC
 SUBDIRS = msvc6 bcb5 config src include tests doc 
 else
@@ -45,13 +49,12 @@ TAGS:: CONTENTS
 
       convenience.h \
 rpm: dist
-	rpm -ta $(PACKAGE)-$(VERSION).tar.gz
-	mv -f /usr/src/redhat/SRPMS/$(PACKAGE)-$(VERSION)-*.rpm $(top_srcdir)
-	mv -f /usr/src/redhat/RPMS/*/$(PACKAGE)-$(VERSION)-*.rpm $(top_srcdir)
-	mv -f /usr/src/redhat/RPMS/*/$(PACKAGE)-devel-$(VERSION)-*.rpm \
-		$(top_srcdir)
-	mv -f /usr/src/redhat/RPMS/*/$(PACKAGE)-doc-$(VERSION)-*.rpm \
-		$(top_srcdir)
+	rpmbuild -ta $(PACKAGE)-$(VERSION).tar.gz
+
+
+debian:
+	chmod a+x $(top_srcdir)/debian/rules
+	dpkg-buildpackage -rfakeroot -sa -us -uc -tc 
 
 docs:
 	$(MAKE) -C doc
diff --git a/autogen.sh b/autogen.sh
index bddc276..2ab57c4 100755
--- a/autogen.sh
+++ b/autogen.sh
@@ -1,18 +1,25 @@
 #!/bin/sh
+#
+# $Id: autogen.sh 1091 2008-06-08 06:37:22Z nicodvb $
+#
+# run this to generate all the initial makefiles, etc.
 
-echo "Adding libtools."
-libtoolize --force --automake
+srcdir=`dirname "$0"`
+test -z "$srcdir" && srcdir=.
 
-echo "Building macros."
-aclocal -I m4 $ACLOCAL_FLAGS
+ORIGDIR=`pwd`
+cd "$srcdir"
 
-echo "Building config header."
-autoheader
+AUTORECONF=${AUTORECONF-autoreconf}
 
-echo "Building makefiles."
-automake   --add-missing
+if ! type $AUTORECONF >/dev/null 2>&1; then
+  echo "**Error**: Missing \`autoreconf' program." >&2
+  echo "You will need the autoconf and automake packages." >&2
+  echo "You can download them from ftp://ftp.gnu.org/pub/gnu/." >&2
+  exit 1
+fi
 
-echo "Building configure."
-autoconf
+test ! -d "$srcdir/m4" &&  mkdir "$srcdir/m4"
+$AUTORECONF -v --install || exit $?
+cd "$ORIGDIR" || exit $?
 
-echo 'run "configure; make"'
diff --git a/configure.in b/configure.in
index 1dba52c..6992347 100644
--- a/configure.in
+++ b/configure.in
@@ -1,4 +1,4 @@
-AC_INIT(log4cpp, 1.1)
+AC_INIT([log4cpp], [1.2.0], [cnangel@gmail.com])
 
 # autoconf 2.50 or higher to rebuild aclocal.m4, because the
 # AC_CREATE_PREFIX_CONFIG_H macro needs the AS_DIRNAME macro.
@@ -19,8 +19,9 @@ AC_SUBST(LT_VERSION)
 AC_CONFIG_AUX_DIR(config)
 AM_CONFIG_HEADER(include/config.h)
 
-AM_INIT_AUTOMAKE
+AM_INIT_AUTOMAKE([log4cpp], [1.2.0])
 
+AC_CONFIG_MACRO_DIR([m4])
 # General "with" options
 # ----------------------------------------------------------------------------
 AC_ARG_WITH(idsa, [  --with-idsa             include idsa support])
diff --git a/debian/Makefile.am b/debian/Makefile.am
new file mode 100644
index 0000000..a8ad9af
--- /dev/null
+++ b/debian/Makefile.am
@@ -0,0 +1,9 @@
+EXTRA_DIST = \
+	changelog control copyright rules \
+	liblog4cpp-dev.dirs \
+	liblog4cpp-dev.files \
+	liblog4cpp-doc.dirs \
+	liblog4cpp-doc.files \
+	liblog4cpp0.dirs \
+	liblog4cpp0.files \
+	liblog4cpp0.postinst
diff --git a/debian/changelog b/debian/changelog
new file mode 100644
index 0000000..81f0b1f
--- /dev/null
+++ b/debian/changelog
@@ -0,0 +1,12 @@
+log4cpp (0.2.4b-0) unstable; urgency=low
+
+  * The debian packaging files in this directory build un-official packages. 
+    Official log4cpp debian packages are available from the debian archives,
+    see http://packages.debian.org/liblog4cpp*.
+
+ -- Marcel Harkema <marcel@debian.org>  Sat, 21 April 2001 13:36:10 +0200
+
+Local variables:
+mode: debian-changelog
+add-log-mailing-address: "marcel@debian.org"
+End:
diff --git a/debian/control b/debian/control
new file mode 100644
index 0000000..e1e8d1f
--- /dev/null
+++ b/debian/control
@@ -0,0 +1,34 @@
+Source: log4cpp
+Section: contrib/devel
+Priority: optional
+Maintainer: Marcel Harkema <marcel@debian.org>
+Standards-Version: 3.5.2
+Build-Depends: debhelper (>> 3.0.0), libtool, doxygen, graphviz
+
+Package: liblog4cpp0
+Architecture: any
+Section: libs
+Depends: ${shlibs:Depends}
+Description: A C++ library for flexible logging
+ Log for C++ is a library of C++ classes for flexible logging to files,
+ syslog and other destinations. It is modeled after the Log for
+ Java library (http://jakarta.apache.org/log4j/), staying as close to
+ their API as is reasonable.
+
+Package: liblog4cpp-dev
+Architecture: any
+Depends: liblog4cpp0 (= ${Source-Version}), libc6-dev
+Description: A C++ library for flexible logging (development files)
+ Log for C++ is a library of C++ classes for flexible logging to files,
+ syslog and other destinations. It is modeled after the Log for
+ Java library (http://jakarta.apache.org/log4j/), staying as close to
+ their API as is reasonable.
+
+Package: liblog4cpp-doc
+Architecture: all
+Description: A C++ library for flexible logging (documentation)
+ Log for C++ is a library of C++ classes for flexible logging to files,
+ syslog and other destinations. It is modeled after the Log for
+ Java library (http://jakarta.apache.org/log4j/), staying as close to
+ their API as is reasonable.
+
diff --git a/debian/copyright b/debian/copyright
new file mode 100644
index 0000000..e43d5e7
--- /dev/null
+++ b/debian/copyright
@@ -0,0 +1,19 @@
+This package was debianized by Marcel Harkema <marcel@debian.org>
+on Sat, 7 Apr 2001 19:24:11 +0100.
+
+Original source has been downloaded from:
+  http://sourceforge.net/projects/log4cpp/
+
+Homepage:
+  http://log4cpp.sourceforge.net/
+
+Copyright:
+  Copyright (C) 2000,2001 LifeLine Networks bv
+  Copyright (C) 2000,2001 Bastiaan Bakker
+
+License:
+  GNU Lesser General Public License.  A copy of the GNU Lesser General
+  Public License, version 2.1, can be found in /usr/share/common-licenses/LGPL-2.1
+
+Debian package maintainer:
+  Marcel Harkema <marcel@debian.org>
diff --git a/debian/liblog4cpp-dev.dirs b/debian/liblog4cpp-dev.dirs
new file mode 100644
index 0000000..38bf9a7
--- /dev/null
+++ b/debian/liblog4cpp-dev.dirs
@@ -0,0 +1,2 @@
+usr/include/log4cpp
+usr/lib
diff --git a/debian/liblog4cpp-dev.files b/debian/liblog4cpp-dev.files
new file mode 100644
index 0000000..62a5128
--- /dev/null
+++ b/debian/liblog4cpp-dev.files
@@ -0,0 +1,4 @@
+usr/lib/liblog4cpp.a
+usr/lib/liblog4cpp.la
+usr/lib/liblog4cpp.so
+usr/include/log4cpp
diff --git a/debian/liblog4cpp-doc.dirs b/debian/liblog4cpp-doc.dirs
new file mode 100644
index 0000000..2ae7ac9
--- /dev/null
+++ b/debian/liblog4cpp-doc.dirs
@@ -0,0 +1 @@
+usr/share/man/man3
diff --git a/debian/liblog4cpp-doc.files b/debian/liblog4cpp-doc.files
new file mode 100644
index 0000000..2ae7ac9
--- /dev/null
+++ b/debian/liblog4cpp-doc.files
@@ -0,0 +1 @@
+usr/share/man/man3
diff --git a/debian/liblog4cpp0.dirs b/debian/liblog4cpp0.dirs
new file mode 100644
index 0000000..6845771
--- /dev/null
+++ b/debian/liblog4cpp0.dirs
@@ -0,0 +1 @@
+usr/lib
diff --git a/debian/liblog4cpp0.files b/debian/liblog4cpp0.files
new file mode 100644
index 0000000..ee5a64d
--- /dev/null
+++ b/debian/liblog4cpp0.files
@@ -0,0 +1 @@
+usr/lib/liblog4cpp.so.*
diff --git a/debian/liblog4cpp0.postinst b/debian/liblog4cpp0.postinst
new file mode 100644
index 0000000..e3d9c57
--- /dev/null
+++ b/debian/liblog4cpp0.postinst
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+if [ "$1" = "configure" ]; then
+  ldconfig
+fi
+
+#DEBHELPER#
diff --git a/debian/rules b/debian/rules
new file mode 100644
index 0000000..dbf2b62
--- /dev/null
+++ b/debian/rules
@@ -0,0 +1,85 @@
+#!/usr/bin/make -f
+
+# Uncomment this to turn on verbose mode. 
+export DH_VERBOSE=1
+
+# This is the debhelper compatibility version to use.
+export DH_COMPAT=3
+
+# This has to be exported to make some magic below work.
+export DH_OPTIONS
+
+build: build-stamp
+build-stamp:
+	dh_testdir
+	if [ -x ./autogen.sh ] ; then ./autogen.sh ; fi
+	./configure --prefix=/usr --mandir=\$${prefix}/share/man
+	$(MAKE)
+	touch build-stamp
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-stamp install-stamp
+	-$(MAKE) clean
+	-$(MAKE) distclean
+	dh_clean
+
+install: DH_OPTIONS=
+install: install-stamp
+install-stamp: build
+	dh_testdir
+	dh_testroot
+	dh_clean -k
+	dh_installdirs
+	# Add here commands to install the package into debian/tmp.
+	$(MAKE) prefix=`pwd`/debian/tmp/usr install
+	dh_movefiles
+	# Copy class documentation (html) to doc/ directory of -doc package.
+	mkdir -p debian/liblog4cpp-doc/usr/share/doc/liblog4cpp-doc/html
+	mv debian/tmp/usr/doc/log4cpp-*/html/* debian/liblog4cpp-doc/usr/share/doc/liblog4cpp-doc/html/
+	touch install-stamp
+
+binary-common:
+	dh_testdir
+	dh_testroot
+#	dh_installdebconf
+	dh_installdocs
+	dh_installexamples
+	dh_installmenu
+#	dh_installlogrotate
+#	dh_installemacsen
+#	dh_installpam
+#	dh_installmime
+#	dh_installinit
+	dh_installman
+	dh_installcron
+	dh_installinfo
+#	dh_undocumented
+	dh_installchangelogs
+	dh_link
+	dh_compress
+	dh_fixperms
+	dh_makeshlibs --noscripts
+	dh_installdeb
+#	dh_perl
+	dh_strip
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
+
+# Build architecture dependant packages using the common target.
+binary-arch: build install
+	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common
+
+# Build architecture independant packages using the common target.
+binary-indep: build install
+	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common
+
+# Any other binary targets build just one binary package at a time.
+binary-%: build install
+	$(MAKE) -f debian/rules binary-common DH_OPTIONS=-p$*
+
+binary: binary-indep binary-arch
+.PHONY: build clean binary-indep binary-arch binary install
diff --git a/doc/Doxyfile.in b/doc/Doxyfile.in
index 73161b0..4bde12d 100644
--- a/doc/Doxyfile.in
+++ b/doc/Doxyfile.in
@@ -62,6 +62,7 @@ COLLABORATION_GRAPH  = YES
 INCLUDE_GRAPH        = YES
 INCLUDED_BY_GRAPH    = YES
 GRAPHICAL_HIERARCHY  = YES
-MAX_DOT_GRAPH_WIDTH    = 1024
-MAX_DOT_GRAPH_HEIGHT   = 1024
+#MAX_DOT_GRAPH_WIDTH    = 1024
+#MAX_DOT_GRAPH_HEIGHT   = 1024
 GENERATE_LEGEND        = YES
+DOT_IMAGE_FORMAT = gif
diff --git a/doc/Makefile.am b/doc/Makefile.am
index e98a555..2a2064f 100644
--- a/doc/Makefile.am
+++ b/doc/Makefile.am
@@ -1,7 +1,7 @@
 SUBDIRS = html
 
 man3dir = $(mandir)/man3
-docdir  = $(prefix)/doc/@PACKAGE_TARNAME@-@PACKAGE_VERSION@
+docdir  = $(datadir)/doc/@PACKAGE_TARNAME@-@PACKAGE_VERSION@
 
 EXTRA_DIST = \
 	mainPage.txt
diff --git a/include/log4cpp/AmberAppender.hh b/include/log4cpp/AmberAppender.hh
new file mode 100644
index 0000000..dabd0bb
--- /dev/null
+++ b/include/log4cpp/AmberAppender.hh
@@ -0,0 +1,140 @@
+/*
+ * AmberAppender.hh
+ *
+ *  Created on: 2012-4-1
+ *      Author: hanyong
+ */
+
+#ifndef _XLOG_AMBERAPPENDER_HH
+#define _XLOG_AMBERAPPENDER_HH
+
+#include <string>
+#include <vector>
+
+#include <log4cpp/Portability.hh>
+#include <log4cpp/LayoutAppender.hh>
+
+#include <amber/client/QueueClient.h>
+
+#include <pca/util/DataItems.h>
+#include <pca/util/thread/threadlock.h>
+
+namespace xlog
+{
+
+/**
+ * 将日志数据发送到 Amber 中, 以进行日志处理.
+ * log4cpp 配置属性:
+ * config: amber 客户端的配置文件路径, 必须 *
+ * category: 日志数据的业务类型, 必须 *
+ * version: 日志数据的版本号, 非必须, 默认为 0
+ * queueName: amber queueName, 非必须, 默认为 "log_queue"
+ * subqueueId: amber 的 subqueueId, 非必须, 默认为 1
+ * bufferThreshold: amber 一次发送数据的缓冲区阈值, 单位为Byte, 非必须, 默认为 102400 (100KB).
+ *      输出日志的总大小超出这个阈值后, 才会被发送到 amber server, 实际的包大小大于或等于这个值.
+ */
+class AmberAppender: public log4cpp::LayoutAppender
+{
+public:
+    AmberAppender(const std::string& name, std::string config, int category, int version,
+            const std::string& queueName, int subqueueId, int bufferThreshold);
+    virtual ~AmberAppender();
+
+public:
+    int initialize();
+    virtual bool reopen();
+    virtual void close();
+
+protected:
+    /**
+     * Appends the LoggingEvent to the amber queue.
+     * @param event the LoggingEvent to layout and append.
+     **/
+    virtual void _append(const log4cpp::LoggingEvent& event);
+
+public:
+    /**
+     * 将 AmberAppender 注册到 log4cpp,
+     * 必须在 log4cpp 初始化前调用.
+     */
+    static int registerClass();
+
+    /**
+     * 初始化所有创建的 AmberAppender 对象.
+     * 必须在 log4cpp 初始化后调用.
+     * 因为 AmberAppender 依赖 amber, amber 依赖 log4cpp,
+     * 所有 AmberAppender 对象必须在 log4cpp 初始化后才能进行初始化.
+     * 初始化 log4cpp 时, 配置的 AmberAppender 仅创建对象, 尚未初始化.
+     */
+    static int initalizeAll();
+
+    static int flushAll();
+
+private:
+    /**
+     * 将缓存数据发送到 amber, 清空缓存.
+     */
+    int flush();
+
+    static Appender* instantiate(const std::string& name, const std::string& config, int category,
+            int version, const std::string& queueName, int subqueueId, int bufferThreshold);
+
+private:
+    /**
+     * amber client.
+     */
+    amber::CQueueClient m_client;
+
+    /**
+     * amber 客户端的配置文件路径.
+     */
+    std::string m_config;
+
+    /**
+     * 日志数据的业务类型.
+     */
+    int m_category;
+
+    /**
+     * 日志数据的版本号.
+     */
+    int m_version;
+
+    std::string m_queueName;
+
+    /**
+     * amber 的 subqueueId.
+     */
+    int m_subqueueId;
+
+    /**
+     * buffer items which will be sent.
+     */
+    pca::DataItems m_items;
+
+    /**
+     * buffer threshold.
+     */
+    int m_bufferThreshold;
+
+    /**
+     * current buffered message's total size.
+     */
+    int m_currentSize;
+
+    /**
+     * buffered message list.
+     */
+    std::vector<std::string> m_messageList;
+
+    pca::Mutex m_mutex;
+
+    /**
+     * 记录创建了 AmberAppender 对象列表,
+     * log4cpp 初始化成功后, 再对这些对象进行初始化.
+     */
+    static std::vector<AmberAppender*> s_instanceList;
+};
+
+} /* namespace xlog */
+#endif /* _LOG4CPP_AMBERAPPENDER_HH */
diff --git a/include/log4cpp/Appender.hh b/include/log4cpp/Appender.hh
index 471e3ad..acf5655 100644
--- a/include/log4cpp/Appender.hh
+++ b/include/log4cpp/Appender.hh
@@ -129,6 +129,46 @@ namespace log4cpp {
          * @returns the filter, or NULL if no filter has been set.
          **/
         virtual Filter* getFilter() = 0;
+
+		/**
+		 * Sets the backup file numbers
+		 **/
+		virtual void setBackupIndex(int nIndex);
+
+		/**
+		 * Gets the backup file numbers
+		 **/
+		virtual int getBackupIndex();
+
+		/**
+		 * Sets the flush threshold in bytes
+		 **/
+		virtual void setFlushThresholdInKB(int nBytes);
+
+		/**
+		 * Gets the flush threshold in bytes
+		 **/
+		virtual int getFlushThresholdInKB();
+
+		/**
+		 * Sets the flush interval microseconds
+		 **/
+		virtual void setFlushInterval(int nMicroSec);
+
+		/**
+		 * Gets the flush interval microseconds
+		 **/
+		virtual int getFlushInterval();
+
+		/**
+		 * Sets whether async flush
+		 **/
+		virtual void setAsyncFlush(bool bAsyncFlush);
+
+		/**
+		 * Check whether async flush
+		 **/
+		virtual bool isAsyncFlush();
         
         private:
         typedef std::map<std::string, Appender*> AppenderMap;
@@ -145,6 +185,17 @@ namespace log4cpp {
     };
 
     typedef std::set<Appender *> AppenderSet;
+
+    typedef Appender* InstantiateAmberAppender(const std::string& name, const std::string& config,
+            int category, int version, const std::string& queueName, int subqueueId, int bufferThreshold);
+
+    /**
+     * set the function used to instantiate an AmberAppender,
+     * which returns NULL if failed.
+     */
+    LOG4CPP_EXPORT void setInstantiateAmberAppender(InstantiateAmberAppender* instantiate);
+
+    LOG4CPP_EXPORT InstantiateAmberAppender* getInstantiateAmberAppender();
 }
 
 #endif // _LOG4CPP_APPENDER_HH
diff --git a/include/log4cpp/Clock.hh b/include/log4cpp/Clock.hh
new file mode 100644
index 0000000..4f21018
--- /dev/null
+++ b/include/log4cpp/Clock.hh
@@ -0,0 +1,38 @@
+/**
+* @file     Clock.h
+* @brief    Utility class to get the current time of different precision.
+*
+* @version  1.0.0
+* @date     2013.1.12
+* @author   yuejun.huyj
+*/
+
+#ifndef __LOG4CPP_CLOCK_H__
+#define __LOG4CPP_CLOCK_H__
+
+#include <sys/time.h>
+#include <stdint.h>
+
+namespace log4cpp
+{
+
+class Clock
+{
+public:
+    Clock();
+    ~Clock();
+
+    // Get the current time in miliseconds
+    static uint64_t nowMS();
+
+    // Get the current time in microseconds
+    static uint64_t nowUS();
+
+private:
+    Clock(const Clock&);
+    Clock &operator = (const Clock&);
+};
+
+}
+
+#endif
diff --git a/include/log4cpp/EventBase.hh b/include/log4cpp/EventBase.hh
new file mode 100644
index 0000000..88659a6
--- /dev/null
+++ b/include/log4cpp/EventBase.hh
@@ -0,0 +1,90 @@
+/**
+* @file     EventBase.h
+* @brief    Deal with the asynchronous batch logging for LayoutAppenders
+*
+* @version  1.0.0
+* @date     2013.1.12
+* @author   yuejun.huyj
+*/
+
+#ifndef __LOG4CPP_EVENT_BASE_H__
+#define __LOG4CPP_EVENT_BASE_H__
+
+#include <log4cpp/LayoutAppender.hh>
+#include <log4cpp/Thread.hh>
+#include <log4cpp/Signaler.hh>
+#include <assert.h>
+#include <sys/epoll.h>
+#include <map>
+#include <list>
+
+
+namespace log4cpp
+{
+
+//
+// EventBase handles the asynchronous signals sent from LayoutAppender. And it also
+// deals with the timeout event of each LayoutAppender. Internally it uses epoll
+// to capture the read and timeout events in a dedicated I/O thread.
+// Note that: currently we only deal with the asynchronous events for *LayoutAppender*.
+//
+class EventBase
+{
+public:
+    // Default flush time interval for each LayoutAppender.
+    static const int s_iDefaultFlushIntervalInMS = 1000; // 1s
+
+    // Maximum number of events the I/O thread can process in one go.
+    static const int s_iMaxIOEvents = 256;
+    
+    EventBase();
+    ~EventBase();
+
+    // Add LayoutAppender into pending list for asynchronous monitoring
+    void AddLayoutAppender(LayoutAppender *pLayoutAppender);
+
+    // Add event fd of LayoutAppenders into epoll for monitoring
+    void MonitorLayoutAppenders(std::list<LayoutAppender *> *pLayoutAppenderList);
+
+    // Check whether I/O worker thread is running
+    bool IsRunning() { return m_bRunning; }
+
+    // Notify the worker I/O thread to exit
+    void notifyStop();
+
+    // Wait until the worker thread exits
+    void wait();
+
+private:
+    threading::Mutex m_pendingListMutex;
+    std::list<LayoutAppender *> *m_pPendingLayoutAppenderList;
+    std::list<LayoutAppender *> *m_pLayoutAppenderList;
+
+    std::map<int, LayoutAppender *> m_mapLayoutAppenders;
+
+    // Minimum flush time interval of the being monitored LayoutAppenders.
+    uint32_t m_iMinimumFlushIntervalInMS;
+    
+private:
+    // Main worker thread routine
+    static void worker_routine(void *pArg);
+
+    // Main event loop
+    void loop();
+
+    // Main epoll file descriptor
+    int m_epollFd;
+
+    // Used for notifying worker thread to exit
+    Signaler m_exitSignaler;
+
+    // Mark whether the I/O worker thread is running
+    bool m_bRunning;
+
+    // Handle of the physical thread doing the event loop and I/O work
+    CThread m_worker;
+};
+
+}
+
+#endif
diff --git a/include/log4cpp/FileAppender.hh b/include/log4cpp/FileAppender.hh
index 7940777..0c542bd 100644
--- a/include/log4cpp/FileAppender.hh
+++ b/include/log4cpp/FileAppender.hh
@@ -13,6 +13,7 @@
 #include <log4cpp/Portability.hh>
 #include <log4cpp/LayoutAppender.hh>
 #include <string>
+#include <list>
 #include <stdarg.h>
 
 namespace log4cpp {
@@ -79,6 +80,42 @@ namespace log4cpp {
         **/
         virtual mode_t getMode() const;
 
+		/**
+    	*@brief set flush interval microseconds 
+    	*/
+    	virtual void setFlushIntervalInMS(int nFlushIntervalInMS);
+		/**
+    	*@brief get flush interval microseconds 
+    	*/
+    	virtual uint64_t getFlushIntervalInMS();
+        /**
+        *@brief write and flush the pending buffer list in the I/O thread asynchronously.
+        */
+        virtual void asyncFlush();
+        /**
+        *@brief flush the pending buffer list aysnchronously if flush interval is due.
+        */
+        virtual void timeoutAsyncFlush(uint64_t now);
+		/**
+		 * Sets the flush threshold in bytes
+		 **/
+		virtual void setFlushThresholdInKB(int nBytes);
+
+		/**
+		 * Gets the flush threshold in bytes
+		 **/
+		virtual int getFlushThresholdInKB();
+
+		/**
+		 * Sets whether async flush
+		 **/
+		virtual void setAsyncFlush(bool bAsyncFlush);
+
+		/**
+		 * Check whether async flush
+		 **/
+		virtual bool isAsyncFlush();
+
         protected:
         virtual void _append(const LoggingEvent& event);
 
@@ -86,6 +123,19 @@ namespace log4cpp {
         int _fd;
         int _flags;
         mode_t _mode;
+
+		int _nFlushThreshold;
+		int _nFlushIntervalInMS;
+		int _nAcculatedBytesSinceLastSignal;
+		int _nAcculatedBytes;
+		int _nLastFlushTimeInMS;
+		bool _bAsyncFlush;
+
+		Signaler _signaler;
+
+		std::list<std::string *> *_pPendingBufferList;
+		std::list<std::string *> *_pBufferList;
+
     };
 }
 
diff --git a/include/log4cpp/LayoutAppender.hh b/include/log4cpp/LayoutAppender.hh
index 640094c..5c9e410 100644
--- a/include/log4cpp/LayoutAppender.hh
+++ b/include/log4cpp/LayoutAppender.hh
@@ -10,10 +10,12 @@
 #ifndef _LOG4CPP_LAYOUTAPPENDER_HH
 #define _LOG4CPP_LAYOUTAPPENDER_HH
 
-#include <string>
 #include <log4cpp/Portability.hh>
 #include <log4cpp/AppenderSkeleton.hh>
 #include <log4cpp/BasicLayout.hh>
+#include <log4cpp/Signaler.hh>
+#include <string>
+#include <stdint.h>
 
 namespace log4cpp {
 
@@ -25,6 +27,8 @@ namespace log4cpp {
         public:
 
         typedef BasicLayout DefaultLayoutType;
+		Signaler m_signaler;
+		threading::Mutex _appendMutex;
 
         LayoutAppender(const std::string& name);
         virtual ~LayoutAppender();
@@ -37,6 +41,22 @@ namespace log4cpp {
          **/
         virtual bool requiresLayout() const;
         virtual void setLayout(Layout* layout = NULL);
+		/**
+    	*@brief set flush threshold
+    	*/
+    	virtual void setFlushIntervalInMS(int nFlushIntervalInMS);
+		/**
+    	*@brief get flush threshold
+    	*/
+    	virtual uint64_t getFlushIntervalInMS();
+        /**
+        *@brief write and flush the pending buffer list in the I/O thread asynchronously.
+        */
+        virtual void asyncFlush();
+        /**
+        *@brief flush the pending buffer list aysnchronously if flush interval is due.
+        */
+        virtual void timeoutAsyncFlush(uint64_t now);
 
         protected:
         /**
@@ -48,6 +68,7 @@ namespace log4cpp {
 
         private:
         Layout* _layout;
+
     };
 }
 
diff --git a/include/log4cpp/Makefile.am b/include/log4cpp/Makefile.am
index 608cef0..a9256f5 100644
--- a/include/log4cpp/Makefile.am
+++ b/include/log4cpp/Makefile.am
@@ -47,7 +47,13 @@ liblog4cppinclude_HEADERS =  \
 	config-win32.h \
 	config-openvms.h \
   config-MinGW32.h \
-	convenience.h
+	convenience.h \
+	TimeRollingFileAppender.hh \
+	Clock.hh \
+	EventBase.hh \
+	Thread.hh \
+	Signaler.hh \
+	$(NULL)
 
 dist-hook:
 	$(RM) -f $(distdir)/config.h
diff --git a/include/log4cpp/Signaler.hh b/include/log4cpp/Signaler.hh
new file mode 100644
index 0000000..92aa599
--- /dev/null
+++ b/include/log4cpp/Signaler.hh
@@ -0,0 +1,63 @@
+/**
+* @file     Signaler.h
+* @brief    Implement a mechanism to do asynchronous notification.
+*
+* @version  1.0.0
+* @date     2013.1.12
+* @author   yuejun.huyj
+*/
+
+#ifndef __LOG4CPP_SIGNALER_H__
+#define __LOG4CPP_SIGNALER_H__
+
+#ifndef likely
+#if __GNUC__ > 2 || __GNUC_MINOR__ >= 96
+#  define likely(x)       __builtin_expect(!!(x),1)
+#  define unlikely(x)     __builtin_expect(!!(x),0)
+#  define expected(x,y)   __builtin_expect((x),(y))
+#else //__GNUC__ > 2 || __GNUC_MINOR__ >= 96
+#  define likely(x)       (x)
+#  define unlikely(x)     (x)
+#  define expected(x,y)   (x)
+#endif //__GNUC__ > 2 || __GNUC_MINOR__ >= 96
+#endif // likely
+
+namespace log4cpp
+{
+
+// This class utilizes socket pair to do asynchronous notification between threads.
+// Its read fd can be polled together with a cluster of fds in the I/O thread.
+class Signaler
+{
+public: 
+    Signaler();
+    ~Signaler();
+
+    // Get the read fd for polling
+    int getFd() { return m_readFd; }
+
+    // Send a byte to the underlying write fd to signal the event
+    void send();
+
+    // Read bytes from the underlying read fd. Note that it may get
+    // several bytes which represents several signals.
+    int recv();
+
+private:
+    static void setSocketUnblock(int socket);
+
+    // Create a pair of file descriptors that will be used to pass the signals.
+    static int makeFdPair(int &readFd, int &writeFd);
+    
+    // Underlying write & read file descriptor.
+    int m_writeFd;
+    int m_readFd;
+    
+    // Disable copying of Signaler object.
+    Signaler(const Signaler &);
+    Signaler& operator=(const Signaler&);
+};
+
+}
+
+#endif
diff --git a/include/log4cpp/Thread.hh b/include/log4cpp/Thread.hh
new file mode 100644
index 0000000..76d60ad
--- /dev/null
+++ b/include/log4cpp/Thread.hh
@@ -0,0 +1,59 @@
+/**
+* @file     Thread.h
+* @brief    Abstraction of the posix thread
+*
+* @version  1.0.0
+* @date     2013.1.14
+* @author   yuejun.huyj
+*/
+
+#ifndef __LOG4CPP_THREAD_H__
+#define __LOG4CPP_THREAD_H__
+
+#include <pthread.h>
+
+namespace log4cpp
+{
+
+typedef void (thread_fn) (void*);
+
+//
+// Class encapsulating OS thread. Thread initiation/termination is done
+// using special functions rather than in constructor/destructor so that
+// thread isn't created during object construction by accident, causing
+// newly created thread to access half-initialised object. Same applies
+// to the destruction process: Thread should be terminated before object
+// destruction begins, otherwise it can access half-destructed object.
+//
+class CThread
+{
+public:
+
+    CThread ()
+    {
+    }
+
+    // Create OS thread. 'tfn' is main thread function. It'll be passed
+    // 'arg' as an argument.
+    void start(thread_fn *tfn, void *pArg);
+
+    // Waits for thread termination.
+    void stop();
+
+    // These are internal members. They should be private, however then
+    // they would not be accessible from the main routine of the thread.
+    thread_fn *m_tfn;
+    void *m_pArg;
+    
+private:
+
+    pthread_t m_threadDescriptor;
+
+    CThread(const CThread&);
+    CThread &operator=(const CThread&);
+};
+
+}
+
+#endif
+
